﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Reflection;

namespace WpfApplication121
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            radPropertyGrid.Item = new TestClass() { IntProperty1 = 5, IntProperty2 = 6, DoubleProperty = 7 };            
        }

        private void radPropertyGrid_AutoGeneratingPropertyDefinition(object sender, Telerik.Windows.Controls.Data.PropertyGrid.AutoGeneratingPropertyDefinitionEventArgs e)
        {
            DataTemplate dt = CustomDataTemplateFactory((sender as RadPropertyGrid).Item.GetType().GetProperty(e.PropertyDefinition.DisplayName).PropertyType, e.PropertyDefinition.DisplayName);
            e.PropertyDefinition.EditorTemplate = dt;
        }

        private DataTemplate CustomDataTemplateFactory(Type type, string path)
        {            
            if (type == typeof(Int32))
            {
                FrameworkElementFactory fe = new FrameworkElementFactory(typeof(RadNumericUpDown));
                fe.SetBinding(RadNumericUpDown.ValueProperty, new Binding(path) {Mode = BindingMode.TwoWay });
                DataTemplate dt = new DataTemplate();
                dt.VisualTree = fe;
                dt.Seal();
                return dt;
            }
            return null;
        }
    }

    public class TestClass
    {
        public int IntProperty1 { get; set; }
        public double DoubleProperty { get; set; }
        public int IntProperty2 { get; set; }
    }
}
